'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('../index'),
    render = _require.render;

var size = {
  width: 200,
  height: 50
};

var ITEMS = [];

for (var i = 0; i < 1000; i += 1) {
  ITEMS.push(i);
}

// Create your react component:
function App() {
  return React.createElement(
    'container',
    {
      style: {
        flex: 1
      }
    },
    React.createElement('button', {
      title: 'click',
      onClick: function onClick() {
        console.log('enTER');
      }
    })
  );
}

// Create a window and a root container:
var win = gui.Window.create({});
win.setContentSize({ width: 400, height: 250 });

var contentView = gui.Container.create();
contentView.setStyle({ flexDirection: 'row' });
win.setContentView(contentView);
win.center();
win.activate();

// Create your react elements and render them:
render(React.createElement(App, null), contentView);

// Start your app
if (!process.versions.yode) {
  gui.MessageLoop.run();
  process.exit(0);
}