'use strict';

var gui = require('gui');

var _require = require('../../index'),
    render = _require.render;

function createTestSuite(ready) {
  // NOTE: Calling yue too early will make addon abort so we wait here.
  setTimeout(function () {
    var next = function next(element, callback) {
      var win = gui.Window.create({});
      var container = gui.Container.create();
      win.setContentView(container);

      render(element, container, function () {
        callback(container);
      });
    };

    ready(next);
  }, 3000);
  // for (let i = 0; i < container.childCount(); i += 1) {
  //   const child = container.childAt(i)
  //   console.log('child', child)
  // }
}

module.exports = {
  createTestSuite: createTestSuite

  // if (module === require.main) {
  //   createTestSuite()
  // }

};