'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('gui'),
    Container = _require.Container;

var Base = require('./base');

module.exports = function (_Base) {
  _inherits(Wrapper, _Base);

  function Wrapper(props, ele) {
    _classCallCheck(this, Wrapper);

    var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, ele || Container.create()));

    _this.update(null, props);
    return _this;
  }

  // TODO: use "lastProps" to avoid unnecessary updating


  _createClass(Wrapper, [{
    key: 'update',
    value: function update(lastProps, props) {
      _get(Wrapper.prototype.__proto__ || Object.getPrototypeOf(Wrapper.prototype), 'update', this).call(this, lastProps, props);

      this.updateSignal('onDraw', props, lastProps);
    }
  }, {
    key: 'addChildView',
    value: function addChildView(child) {
      this._ele.addChildView(child._ele);
    }
  }, {
    key: 'removeChildView',
    value: function removeChildView(child) {
      this._ele.removeChildView(child._ele);
    }
  }, {
    key: 'insertBefore',
    value: function insertBefore(child, beforeChild) {
      var count = this._ele.childCount();
      var targetEle = beforeChild._ele;

      for (var i = 0; i < count; i += 1) {
        var ele = this._ele.childAt(i);

        if (targetEle === ele) {
          this._ele.addChildViewAt(child._ele, i);
          return;
        }
      }

      this._ele.addChildView(child._ele);
    }
  }]);

  return Wrapper;
}(Base);