'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('gui'),
    ProgressBar = _require.ProgressBar;

var Base = require('./base');

var _require2 = require('../utils'),
    shoudUpdate = _require2.shoudUpdate;

module.exports = function (_Base) {
  _inherits(Wrapper, _Base);

  function Wrapper(props) {
    _classCallCheck(this, Wrapper);

    var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, ProgressBar.create()));

    _this.update(null, props);
    return _this;
  }

  _createClass(Wrapper, [{
    key: 'update',
    value: function update(lastProps, props) {
      _get(Wrapper.prototype.__proto__ || Object.getPrototypeOf(Wrapper.prototype), 'update', this).call(this, lastProps, props);

      if (shoudUpdate(props, lastProps, 'value')) {
        this._ele.setValue(props.value);
      }

      if (shoudUpdate(props, lastProps, 'indeterminate')) {
        this._ele.setIndeterminate(props.indeterminate);
      }

      this.updateSignal('onClick', props, lastProps);
    }
  }]);

  return Wrapper;
}(Base);